unit umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, FileUtil, Forms, Controls, Graphics,
  Dialogs, StdCtrls, db;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function LoadFile(FilePath: string): string;
var
  fm: tfilestream;
  s: string;
begin
  fm := tfilestream.Create(FilePath, fmopenread);
  try
    setlength(s, fm.size);
    fm.Read(s[1], fm.size);
  finally
    fm.Free;
  end;
  Result := s;
  setlength(s, 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: longint;
  Origin: string;
  sl: TStringList;
begin
  SQLite3Connection1.DatabaseName := './DB_sqlite';
  SQLTransaction1.Database := SQLite3Connection1;
  SQLite3Connection1.Open;
  if SQLite3Connection1.Connected then
    Form1.Caption := 'Verbindung hergestellt';
  SQLQuery1.Transaction := SQLTransaction1;

  //Erzeugt Wörterbuchliste
  SQLQuery1.SQL.Text := 'CREATE TABLE IF NOT EXISTS tblDictonary (ID INTEGER Primary KEY, Wort VARCHAR(255) UNIQUE ON CONFLICT IGNORE);';
  SQLQuery1.ExecSQL;
  SQLTransaction1.commit;


  Origin := Loadfile('./test.txt');
  Origin := Stringreplace(Origin, '"', '', [rfReplaceAll]);
  sl := TStringList.Create;
  try
    sl.Delimiter := ' ';
    sl.QuoteChar := #$0;
    sl.DelimitedText := Origin;
    SQLQuery1.Close;
    SQLQuery1.Params.Clear;
    SQLQuery1.SQL.Text := 'INSERT INTO tblDictonary (Wort) VALUES (:sWort)';
    SQLQuery1.Prepare;
    for i := 0 to sl.Count - 1 do
    begin
      SQLQuery1.ParamByName('sWort').AsString:= sl[i];
      SqlQuery1.ExecSQL;
      //SqlTransaction1.Commit;
       if i mod 1000 = 0 then
       begin
         SqlTransaction1.Commit;
         Form1.Caption := IntToStr(i);
       end;
    end;
  finally
    sl.Free;
  end;
  SQLQuery1.Close;
end;

end.

